R.<x,y,a,b,c,f>=QQ['x,y,a,b,c,f']
# f = floor((x + y + a + b + c)/2)

print("Creating Sage lists of polynomials and cones from txt files...")

file = open('polynomials_u.txt', "r")
listePoly=[] # List of (quasi)-polynomials without repetition 
for l in file : listePoly.append(R(l))
file.close()


file = open('polynomials_l.txt', "r")
listePoly_l=[] # List of (quasi)-polynomials with repetition 
for l in file : listePoly_l.append(R(l))
file.close()

file = open('cones_l.txt', "r")
listeCones_l=[] # List of cones with repetition 
for l in file : listeCones_l.append(l)
file.close()


print('Check if the list  of polynomials is stable by symmetry...')

listePolModulo=[]
for P in listePoly : # Check that the list of polynomials is stable by the involution
      	 	     # Make the list listePolModulo with one representative of each orbit
    if P(y,x,a,b,c,f) not in listePoly :
       print('Zut')
    if listePoly.index(P)<=listePoly.index(P(y,x,a,b,c,f)) : listePolModulo.append(P)

print("Associating cones with polynomials...")

ConesByPol=[[],[],[],[]] # Four lists for true or quasi polinomial symmetric or not.
ConesByPolSym=[[],[]] # Cones of P(y,x) by type True or Quasi
polByType=[[],[],[],[]] 
for P in listePolModulo :
    if P==P(x,y,a,b,c,0) and P==P(y,x,a,b,c,0) : typeP=0 # True Sym
    elif P==P(x,y,a,b,c,0) : typeP=1                    # True Non Sym
    elif P==P(y,x,a,b,c,f) : typeP=2                    # Quasi Sym
    else : typeP=3                                        # Quasi Non Sym
    polByType[typeP].append(P)
    ConesP=[]
    ConesPs=[]
    for i,e in enumerate(listePoly_l):
    	if e==P :
	   ConesP.append(listeCones_l[i])
	if typeP % 2 ==1 and e==P(y,x,a,b,c,f) :
	   ConesPs.append(listeCones_l[i])
    ConesByPol[typeP].append(ConesP)
    if typeP % 2 ==1 : ConesByPolSym[(typeP-1)/2].append(ConesPs)

print("Writing Output with Barvinok cones")

file = open('polynomials_Modulo_With_Cones.txt',"w")
file.write('############################################## \n')
file.write('# Symmetric True Polynomials and their Cones # \n')
file.write('############################################## \n\n')
i=0
for P in polByType[0] :
    file.write(str(P)+'\n\n')
    for c in ConesByPol[0][i] : file.write(c)
    file.write('\n')
    file.write('----\n')
    i=i+1
    
file.write('############################################### \n')
file.write('# Symmetric Quasi Polynomials and their Cones # \n')
file.write('############################################### \n\n')
i=0
for P in polByType[2] :
    file.write(str(P)+'\n\n')
    for c in ConesByPol[2][i] : file.write(c)
    file.write('\n')
    file.write('----\n')
    i=i+1

file.write('################################################## \n')
file.write('# Non Symmetric True Polynomials and their Cones # \n')
file.write('################################################## \n\n')
i=0
for P in polByType[1] :
    file.write(str(P)+'\n\n')
    for c in ConesByPol[1][i] : file.write(c)
    file.write('\n')
    file.write('-- \n')
    for c in ConesByPolSym[0][i] : file.write(c)
    file.write('\n')
    file.write('----\n')
    i=i+1

file.write('################################################### \n')
file.write('# Non Symmetric Quasi Polynomials and their Cones # \n')
file.write('################################################### \n\n')
i=0
for P in polByType[3] :
    file.write(str(P)+'\n\n')
    for c in ConesByPol[3][i] : file.write(c)
    file.write('\n')
    file.write('-- \n')
    for c in ConesByPolSym[1][i] : file.write(c)
    file.write('\n')
    file.write('----\n')
    i=i+1
file.close()


#####################
print('Gluing the cones associated to a given polynomials...')

dico={}
dico['x']=0
dico['y']=1
dico['a']=2
dico['b']=3
dico['c']=4

alphabet=['x','y','a','b','c']

def termetov(t,sgn,v) :
    for lettre in alphabet :
    	if (t.count('-'+lettre)==1 or t.count('- '+lettre)==1): v[dico[lettre]]=-1*sgn
    	elif (t.count(lettre)==1) : v[dico[lettre]]=sgn

def termestov(tp,tm,v) :
    termetov(tp,1,v)
    termetov(tm,-1,v)

def ineqstov(e) :
    v=vector(ZZ,5);w=vector(ZZ,5)
    if e.count('>')==1 :
       termes=e.split('>')
       termestov(termes[0],termes[1],v)
       return([v])
    elif e.count('<')==1:
       termes=e.split('<')
       termestov(termes[1],termes[0],v)
       return([v])
    elif e.count('>')==2 :
       termes=e.split('>')
       termestov(termes[0],termes[1],v)
       v=vector(ZZ,5)
       termestov(termes[1],termes[2],w)
       return([v,w])
    else :
       termes=e.split('<')
       termestov(termes[1],termes[0],v)
       termestov(termes[2],termes[1],w)
       return([v,w])

def conetomat(l) :
    listeineq=[]
    for e in l.split('and') :
	listeineq = listeineq +ineqstov(e)
    listeineq.sort()
    return(matrix(ZZ,listeineq))


#print(conetomat(ConesByPolSym[1][2][0]))
def add_zero(L):
#input : a list of lists
#output : each list has 0 added at the beginning
    ll=[]
    for i in L: ll.append([0]+i)      
    return ll;

def rows_as_lists_except(A,i0):
#renvoie une liste des lignes de la matrice A, sauf la numéro i0, représentées par la liste de leurs éléments
    L=[];
    for i in range(A.nrows()):
        if i!=i0:
            l=[];
            for j in range(A.ncols()):
                l.append(A[i,j]);
            L.append(l);
    return L;

def rows_opp(A,B):
#If matrices A and B have opposite rows, return the numbers of rows. Otherwise return 0.
    for i in range(A.nrows()):
        for j in range(B.nrows()):
            if A[i,:]==-B[j,:]:
                return (i,j);
    return 0;

def ineqs_check_rays(Lineqs,Lrayons):
#reçoit une liste d'inégalités et une de rayons, et renvoie la liste des inég vraies sur tous les rayons
    L=[];
    for ineq in Lineqs:
        ineq_vraie=True;
        for rayon in Lrayons:
            eval=0;
            for i in range(len(ineq)):
                eval=eval+ineq[i]*rayon[i];
            ineq_vraie=ineq_vraie and (eval>=0);
        if ineq_vraie:
            L.append(ineq);
    return L;    

def glue_cones(L):
#input : a list of matrices. Each matrix is a list of inequalities (one by row), hence a cone.
#output : idem : a list of cone with the same union
    if len(L)==1:
        return L;
    else:
        for i in range(len(L)):
            A=L[i];
            CA=Polyhedron(ieqs=add_zero(rows_as_lists_except(A,-1)+rows_as_lists_except(matrix.identity(A.ncols()),-1)));
            IA=matrix(CA.inequalities_list())[:,range(1,A.ncols()+1)];
            for j in range(i+1,len(L)):
                B=L[j];
                CB=Polyhedron(ieqs=add_zero(rows_as_lists_except(B,-1)+rows_as_lists_except(matrix.identity(A.ncols()),-1)));
                IB=matrix(CB.inequalities_list())[:,range(1,A.ncols()+1)];
                if rows_opp(IA,IB)!=0:
                    (i0,j0)=rows_opp(IA,IB);
                    LA=rows_as_lists_except(IA,i0);
                    LB=rows_as_lists_except(IB,j0);
                    RA=CA.rays_list();
                    RB=CB.rays_list();
                    if (len(ineqs_check_rays(LA,RB))==len(LA)) and (len(ineqs_check_rays(LB,RA))==len(LB)):
                        C0=Polyhedron(ieqs=add_zero(LA+LB));
                        M=matrix(C0.inequalities_list())[:,range(1,A.ncols()+1)];
                        Ln=L[0:i]+[M]+L[i+1:j]+L[j+1:len(L)];
                        return glue_cones(Ln);
        return L;
    

gConesByPol=[[],[],[],[]] # Four lists for true or quasi polinomial symmetric or not.
gConesByPolSym=[[],[]]

for typeP in range(4):
    for listeC in ConesByPol[typeP]:
        listeconestobeglued=[]
    	for l in listeC : listeconestobeglued.append(conetomat(l))
        gConesByPol[typeP].append(glue_cones(listeconestobeglued))
      


for typeP in range(2):
    for listeC in ConesByPolSym[typeP]:
        listeconestobeglued=[]
    	for l in listeC : listeconestobeglued.append(conetomat(l))
        glue_cones(listeconestobeglued)
        gConesByPolSym[typeP].append(glue_cones(listeconestobeglued))


print("Writing Output with glued cones")

file = open('polynomials_Modulo_With_Glued_Cones.txt',"w")
file.write('############################################## \n')
file.write('# Symmetric True Polynomials and their Cones # \n')
file.write('############################################## \n\n')
i=0
for P in polByType[0] :
    file.write(str(P)+'\n\n')
    for c in gConesByPol[0][i] : file.write(str(c))
    file.write('\n')
    file.write('----\n')
    i=i+1
    
file.write('############################################### \n')
file.write('# Symmetric Quasi Polynomials and their Cones # \n')
file.write('############################################### \n\n')
i=0
for P in polByType[2] :
    file.write(str(P)+'\n\n')
    for c in gConesByPol[2][i] : file.write(str(c))
    file.write('\n')
    file.write('----\n')
    i=i+1

file.write('################################################## \n')
file.write('# Non Symmetric True Polynomials and their Cones # \n')
file.write('################################################## \n\n')
i=0
for P in polByType[1] :
    file.write(str(P)+'\n\n')
    for c in gConesByPol[1][i] : file.write(str(c))
    file.write('\n')
    file.write('-- \n')
    for c in gConesByPolSym[0][i] : file.write(str(c))
    file.write('\n')
    file.write('----\n')
    i=i+1

file.write('################################################### \n')
file.write('# Non Symmetric Quasi Polynomials and their Cones # \n')
file.write('################################################### \n\n')
i=0
for P in polByType[3] :
    file.write(str(P)+'\n\n')
    for c in gConesByPol[3][i] : file.write(str(c))
    file.write('\n')
    file.write('-- \n')
    for c in gConesByPolSym[1][i] : file.write(str(c))
    file.write('\n')
    file.write('----\n')
    i=i+1
file.close()
